

           %----------------%
\chapter{~~Internal details}\label{\numb section 13}
           %----------------%

This section contains material intended to assist the developer in reading the source code
of \maniFEM.
It contains mainly drawings which document specific parts of \maniFEM.

% files below are refered in frontal-3d.cpp
% diamond-01.msh diamond-02.msh
% membrane-01.msh membrane-01.png membrane-02.msh membrane-02.png
% membrane-03.msh membrane-03.png membrane-04.msh membrane-04.png membrane-05.msh
% mere-touch-01.msh
% tetrahedra-01.msh tetrahedra-02.msh tetrahedra-03.msh tetrahedra-03.png
% tetrahedra-04.msh tetrahedra-05.msh tetrahedra-06.msh
% valley-01.msh valley-02.msh

          %----------------------------%
\section{~~Building a chain of segments}\label{\numb section 13.\numb parag 1}
          %----------------------------%

One of the simplest meshes is an open chain of segments.

An object like
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
\end{Verbatim}
receives two vertices and the desired number of segments and builds the chain.
New vertices are built by using the {\small\tt \verm{Cell}} constructor with
{\small\tt\taag::vertex}.
Space coordinates of each new vertex are defined by interpolating the coordinates of the
two extremities of the chain.
New segments are built by means of constructor {\small\tt \verm{Cell}} {\small\tt(}
{\small\tt\taag::segment,} {\small\tt A,} {\small\tt B} {\small\tt )},
where {\small\tt A} is a {\small\tt \verm{Cell}::Negative::Vertex} and {\small\tt B} is a
{\small\tt \verm{Cell}::Positive::Vertex}.

Note that the interpolation operation is a method belonging to {\small\tt \verm{Manifold}::working}
which is the most recently declared {\small\tt \verm{Manifold}} object.
For a Euclidian manifold, this is just a convex combination of the values of the coordinates.
However, for other manifolds it may be a more complex operation.
For an implicit manifold, it involves a projection operation, as explained in paragraph
\ref{\numb section 8.\numb parag 1}.

This constructor builds a {\small\tt\verm{Mesh}::Connected::OneDim}
(see paragraph \ref{\numb section 12.\numb parag 6}).
Thus, we can later retrieve the starting vertex through methods
{\small\tt\verm{Mesh}::first\_\,vertex} and {\small\tt\verm{Mesh}::last\_\,vertex}
(both methods return a positive vertex {\small\tt\verm{Cell}}).

For meshing curves on a quotient manifold, we must add a call to the method {\small\tt winding},
providing as argument the winding number of the segment to be built.
If this winding number is zero, the call to method {\small\tt winding} may be omitted.
Several examples are shown in section \ref{\numb section 7}.


          %-----------------------------%
\section{~~Building a mesh of rectangles}\label{\numb section 13.\numb parag 2}
          %-----------------------------%

An object like
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
\end{Verbatim}
builds a rectangular mesh from its
four sides (which are one-dimensional meshes, that is, chains of segments).
No need to provide the number of divisions, the four sides already have their internal divisions.
Of course, opposite sides should have the same number of (segment) cells.

Paragraphs \ref{\numb section 1.\numb parag 4}, \ref{\numb section 1.\numb parag 5} and
many others (e.g. in section \ref{\numb section 2}) show the use of this constructor.

{\ManiFEM} chooses the orientation of the mesh based on the orientation of the four sides,
as provided by the user.
These orientations must be mutually compatible, i.e.\ last vertex of a side must be equal to
the first vertex of the side following it.
If we switch all four orientations, {\maniFEM} will produce the same two-dimensional mesh
with opposite orientation.
If we switch the orientation of some, but not all, of the sides, {\maniFEM} will complain
that the orientations are not compatible with each other.

Actually, the name {\small\tt rectangle} is misleading.
Perhaps a better name would be {\small\tt quadrangle} but even this is not general enough to
describe the constructor's ability to build curved patches like the ones shown in paragraphs
\ref{\numb section 1.\numb parag 1}, \ref{\numb section 2.\numb parag 9}\,--\,%
\ref{\numb section 2.\numb parag 11}, \ref{\numb section 2.\numb parag 13} or
\ref{\numb section 2.\numb parag 14}.
Tags {\small\tt rectangle}, {\small\tt quadrangle} and {\small\tt quadrilateral} can be used
interchangeably.
However, high distortions (e.g.\ high curvature) of the four sides should be avoided;
you should use smaller patches, to be subsequently {\small\tt join}ed.
Other alternatives are extruded meshes, described in section \ref{\numb section 4},
or, if you are willing to accept triangles instead of quadrilaterals,
frontal mesh generation, described in section \ref{\numb section 3}.

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{south}{\small\tt\textcolor{textindraw}{south}}
  \psfrag{east}{\small\tt\textcolor{textindraw}{east}}
  \psfrag{north}{\small\tt\textcolor{textindraw}{north}}
  \psfrag{west}{\small\tt\textcolor{textindraw}{west}}
  \includegraphics[width=85mm]{fig-rectangle}
  \caption{meshing a rectangle}
  \label{\numb section 13.\numb fig 1}
\end{figure}

The coordinates of each new vertex are defined by interpolating the coordinates of four vertices
on the four given sides, as shown in figure \ref{\numb section 13.\numb fig 1}.
The complicated formula for the coefficients (involving $ \alpha^3 $ and $ \beta^3 $) is there
to ensure a smooth transition for the distribution of inner vertices in the case of non-uniform
distribution along one or several sides, or in the case of curved sides.
Paragraphs \ref{\numb section 2.\numb parag 1}, \ref{\numb section 2.\numb parag 11},
\ref{\numb section 2.\numb parag 13} and \ref{\numb section 2.\numb parag 19} show
examples where this is useful.

The remarks made in paragraph \ref{\numb section 13.\numb parag 1} about
the interpolation operation hold here.
Paragraphs \ref{\numb section 2.\numb parag 9}, \ref{\numb section 2.\numb parag 13} and
\ref{\numb section 2.\numb parag 16} show examples where the interpolation operation
consists of a convex combination followed by a projection.
For a manifold defined through an external parameter, the convex combination is performed
on the external parameter and then the space coordinates are computed accordingly
(paragraph \ref{\numb section 2.\numb parag 24} shows such a situation).

A call to method {\small\tt with\_\,triangles} makes the constructor
cut each rectangle in halves; results are shown in paragraphs \ref{\numb section 2.\numb parag 5},
\ref{\numb section 2.\numb parag 10} and \ref{\numb section 2.\numb parag 16}.

For meshing domains of a quotient manifold, we must add a call to method {\small\tt winding}.
No need to provide any winding number, this information is already contained in the four sides.
Examples are shown in paragraphs \ref{\numb section 7.\numb parag 3}\,--\,%
\ref{\numb section 7.\numb parag 8}, \ref{\numb section 7.\numb parag 10},
\ref{\numb section 7.\numb parag 14}, \ref{\numb section 7.\numb parag 17},
\ref{\numb section 7.\numb parag 18}.


          %----------------------------%
\section{~~Building a mesh of triangles}\label{\numb section 13.\numb parag 3}
          %----------------------------%

Building a triangular mesh involves an algorithm much alike the one for a rectangular mesh.
A noteworthy difference is that the interpolation operation involves now six vertices on
the boundary of the triangle, as shown in figure \ref{\numb section 13.\numb fig 2}.

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{S}{\small\tt\textcolor{textindraw}{S}}
  \psfrag{P_AB}{\small\tt\textcolor{textindraw}{P\_\,AB}}
  \psfrag{Q_AB}{\small\tt\textcolor{textindraw}{Q\_\,AB}}
  \psfrag{P_BC}{\small\tt\textcolor{textindraw}{P\_\,BC}}
  \psfrag{Q_BC}{\small\tt\textcolor{textindraw}{Q\_\,BC}}
  \psfrag{P_CA}{\small\tt\textcolor{textindraw}{P\_\,CA}}
  \psfrag{Q_CA}{\small\tt\textcolor{textindraw}{Q\_\,CA}}
  \includegraphics[width=75mm]{fig-triangle}
  \caption{meshing a triangle}
  \label{\numb section 13.\numb fig 2}
\end{figure}

The coefficients for the interpolation have simpler formulas when compared with the ones in the
constructor of a rectangle (presented in paragraph \ref{\numb section 13.\numb parag 2});
the fact that we interpolate from six vertices compensates that.

Examples are presented in paragraphs \ref{\numb section 1.\numb parag 5},
\ref{\numb section 1.\numb parag 6}, \ref{\numb section 2.\numb parag 2},
\ref{\numb section 2.\numb parag 8}, \ref{\numb section 2.\numb parag 12} and
\ref{\numb section 2.\numb parag 16}.

Just like for a rectangular mesh (see paragraph \ref{\numb section 13.\numb parag 2}),
{\maniFEM} chooses the orientation of the mesh based on the orientation of the three sides,
as provided by the user.
Also, the number of divisions is inferred from the three sides.

These three sides may be curves in the plane $ \mathbb{R}^2 $ or in the space $ \mathbb{R}^3 $
(or even in higher dimensional spaces).
However, high distortions (e.g.\ high curvature) of the sides should be avoided;
you should use either smaller patches, to be susbequently {\small\tt join}ed,
or frontal mesh generation, described in section \ref{\numb section 3}.

For meshing domains of a quotient manifold, we must add a call to method {\small\tt winding}.
No need to provide any winding number, this information is already contained in the three sides.
Examples are shown in paragraphs \ref{\numb section 7.\numb parag 9},
\ref{\numb section 7.\numb parag 15}, \ref{\numb section 7.\numb parag 16}.


          %------------------------%
\section{~~Building a mesh of cubes}\label{\numb section 13.\numb parag 4}
          %------------------------%

The process of meshing a cube is similar to meshing a square; it is done layer by layer.
Unlike for a square, where we have used an {\small\tt std::list} of {\small\tt\verm{Cell}}\hglue0.5pt s
{\small\tt horizon}, here we use a {\small\tt\verm{Mesh}} {\small\tt front} which
keeps the newly built faces.
The advantage of using a {\small\tt\verm{Mesh}} instead of a {\small\tt list} of
{\small\tt\verm{Cell}}\hglue0.5pt s is that we can navigate through it as described in paragraph
\ref{\numb section 9.\numb parag 8}.
When we are on a quotient manifold (situation signaled by calling the method {\small\tt winding}),
the six faces  provided as arguments may be in very awkward positions;
this makes it impossible to use one {\small\tt\verm{Mesh}} {\small\tt front} and we have
to use three distinct meshes instead.

\begin{figure}[ht] \centering
  \psfrag{S}{\small\tt\textcolor{textindraw}{ver\_\,south}}
  \psfrag{N}{\small\tt\textcolor{textindraw}{ver\_\,north}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{ver\_\,east}}
  \psfrag{W}{\small\tt\textcolor{textindraw}{ver\_\,west}}
  \psfrag{up}{\small\tt\textcolor{textindraw}{ver\_\,up}}
  \includegraphics[width=100mm]{build-cube}
  \caption{meshing a cube}
  \label{\numb section 13.\numb fig 3}
\end{figure}

Just like for a rectangular mesh (see paragraph \ref{\numb section 13.\numb parag 2}) or for
a triangular one (see paragraph \ref{\numb section 13.\numb parag 3}),
{\maniFEM} chooses the orientation of the mesh based on the orientation of the six faces,
as provided by the user.
Also, the number of divisions is inferred from the faces.

The six faces may be curved, as in paragraph \ref{\numb section 2.\numb parag 15}.
However, faces with high distortions (e.g.\ high curvature) should be avoided;
you should use smaller patches, to be subsequently {\small\tt join}ed.
Other alternatives are extruded meshes, described in section \ref{\numb section 4},
or, if you are willing to accept tetrahedra instead of hexahedra,
frontal mesh generation, described in section \ref{\numb section 3}.

For meshing domains of a quotient manifold, we must add a call to the {\small\tt winding} method.
No need to provide any winding number, this information is already contained in the six faces
(or rather, in the twelve edges).


          %-----------------------------%
\section{~~Building a mesh of tetrahedra}\label{\numb section 13.\numb parag 5}
          %-----------------------------%

It is possible to fill a big triangle with many small identical triangles, as shown in paragraph
\ref{\numb section 13.\numb parag 3}.
It is possible to fill a big rectangle with many small identical rectangles, as shown in paragraph
\ref{\numb section 13.\numb parag 2}.
It is possible to fill a big cube with many small cubes, as shown in paragraph
\ref{\numb section 13.\numb parag 4}.
But it is not possible to fill, say, a big regular tetrahedron with many small regular tetrahedra.
This is why there is no {\small\tt\verm{Mesh}} constructor with
{\small\tt\taag::tetrahedron}.
Frontal mesh generation is available (see section \ref{\numb section 3})
but builds irregular tetrahedrals cells.


          %-----------------------%
\section{~~Frontal mesh generation}\label{\numb section 13.\numb parag 6}
          %-----------------------%

Several flavors of {\small\tt \verm{Mesh}::Build}\,ers with
{\small\tt\taag::frontal} are defined in {\small\tt frontal.cpp};
they build a mesh on a given manifold starting with almost nothing.
For a one-dimensional manifold, a mesh of segments is built.
For a two-dimensional manifold, triangular cells are used.
For a three-dimensional manifold, tetrahedral cells are used.

Frontal mesh generation on a two-dimensional manifold starts with the boundary of
the future mesh, then moves this interface with small steps, building the mesh behind it
like a spider.
Actually, if the manifold is compact (like the sphere or the torus) and we want to mesh
all of it, there will be no boundary.
In this case we can start the process by providing nothing more than the manifold itself
(or not even that -- the current working manifold will be meshed in this case).
The mesh follows the shape of the manifold; this is achieved by {\small\tt project}ing
newly created vertices on the working manifold, as explained in paragraph
\ref{\numb section 8.\numb parag 1}.
Section \ref{\numb section 3} gives several examples.

This is a complex process, much more complex than building a regular mesh of rectangles
(as described in paragraph \ref{\numb section 13.\numb parag 2}) or of triangles (as described
in paragraph \ref{\numb section 13.\numb parag 3}).

The initial interface may be disconnected.
Even if the initial interface is connected, it may become disconnected during the meshing
process, if it touches itself (paragraph \ref{\numb section 13.\numb parag 11}
discusses this event).

Detecting such touching points requires the evaluation of the distance
between many pairs of points.
This may become extremely time consuming, unless special care is taken.
Points belonging to the interface are organized in a hierarchy allowing one
to eliminate many pairs of points from the evaluation process.
Paragraph \ref{\numb section 13.\numb parag 14} describes this hierarchy.

The next few paragraphs describe specific parts of this process of frontal mesh generation.


          %----------%
\section{~~The metric}\label{\numb section 13.\numb parag 7}
          %----------%

One of the first things the frontal meshing algorithm does is to change the metric of the
current working manifold, by re-scaling it with the inverse of the desired segment length
which was provided by the user after {\small\tt\taag::desired\_\,length}.
This way, the rest of the algorithm seeks to build segments of length as close to $1$ as possible
(measured by the modified Riemann metric).

One of the advantages of this approach is that the bulk of the mesh generation algorithm is
independent of the type of metric.
The code is the same for a uniform or a non-uniform metric, or even for an anisotropic metric.


          %----------------%
\section{~~Measuring angles}\label{\numb section 13.\numb parag 8}
          %----------------%

We often need to measure angles between adjacent segments of the interface
(when building a 2D mesh) or between adjacent triangles of the interface
(when building a 3D mesh).
For efficiency reasons, we prefer to avoid invoking (inverses of) trigonometric functions.
Thus, we define two functions {\small\tt angle\_2d} and {\small\tt angle\_3d} which give
an indication of the angle by computing only inner products between vectors (tangent vectors
and normal ones).

For a two-dimensional mesh (one-dimensional interface), we look at adjacent segments
{\small\tt AB} and {\small\tt BC}.
Denote by $ \vec\tau_{\mbox{\scriptsize\tt AB}} $ and $ \vec\tau_{\mbox{\scriptsize\tt BC}} $
the tangent vectors (of norm $1$) and by $ \vec n_{\mbox{\scriptsize\tt AB}} $ and
$ \vec n_{\mbox{\scriptsize\tt BC}} $ the normal vectors (or norm $1$),
as depicted in figure \ref{\numb section 13.\numb fig 4}.
The situation for a three-dimensional mesh (two-dimensional interface) is similar.
Paragraph \ref{\numb section 13.\numb parag 9} explaines the orientation of normal vectors.

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{nab}{\textcolor{textindraw}{$\vec n_{\mbox{\scriptsize\tt AB}}$}}
  \psfrag{nbc}{\textcolor{textindraw}{$\vec n_{\mbox{\scriptsize\tt BC}}$}}
\begin{subfigure}{70mm}\centering
  \includegraphics[width=50mm]{angle-a}
\end{subfigure}  
\begin{subfigure}{70mm}\centering
  \includegraphics[width=60mm]{angle-b}
\end{subfigure}  
  \centerline{(a)\hskip60mm (b)}
\begin{subfigure}{70mm}\centering
  \includegraphics[width=53mm]{angle-c}
\end{subfigure}  
\begin{subfigure}{60mm}\centering
  \includegraphics[width=48mm]{angle-d}
\end{subfigure}  
  \centerline{(c)\hskip60mm (d)}
  \caption{measuring angles}
  \label{\numb section 13.\numb fig 4}
\end{figure}

We have chosen the quantity below (varying between $-3$ and $3$) to describe the angle\,:

$$
  q = \left\{\begin{matrix}
  \vec n_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} - 2 \,,&
  \mbox{if }\ \vec\tau_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} \le 0
  \ \mbox{ and }\ \vec n_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} \le 0\,,
  \quad\mbox{figure \ref{\numb section 13.\numb fig 4} (a)} \cr
  \vec n_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} +
  \vec\tau_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} - 1 \,,&
  \mbox{if }\ \vec\tau_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} \le 0
  \ \mbox{ and }\ \vec n_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} > 0\,,
  \quad\mbox{figure \ref{\numb section 13.\numb fig 4} (b)} \cr
  1 - \vec n_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} +
  \vec\tau_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} \,,&
  \mbox{if }\ \vec\tau_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} > 0
  \ \mbox{ and }\ \vec n_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} > 0\,,
  \quad\mbox{figure \ref{\numb section 13.\numb fig 4} (c)} \cr
  2 - \vec n_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} \,,&
  \mbox{if }\ \vec\tau_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} > 0
  \ \mbox{ and }\ \vec n_{\mbox{\scriptsize\tt AB}} \cdot \vec n_{\mbox{\scriptsize\tt BC}} \le 0\,,
  \quad\mbox{figure \ref{\numb section 13.\numb fig 4} (d)}
  \end{matrix}\right.
$$

Figure \ref{\numb section 13.\numb fig 5} shows the behaviour of $q$ as the angle between
{\small\tt AB} and {\small\tt BC} widens; the origin corresponds to a flat boundary.
  
\begin{figure}[ht] \centering
  \psfrag{q}{$q$}
  \psfrag{1}{$1$}
  \psfrag{2}{$2$}
  \psfrag{3}{$3$}
  \psfrag{O}{$0$}
  \psfrag{-1}{$-1$}
  \psfrag{-2}{$-2$}
  \psfrag{-3}{$-3$}
  \includegraphics[width=110mm]{angles}
  \caption{behaviour of $q$}
  \label{\numb section 13.\numb fig 5}
\end{figure}


          %-----------%
\section{~~The normals}\label{\numb section 13.\numb parag 9}
          %-----------%

The meshing process described in paragraph \ref{\numb section 13.\numb parag 6} uses a set of
normal vectors.
Each cell in the interface has associated to it
a vector tangent to the working manifold and normal to the interface.
We can think of the interface as a curve embedded in the current working manifold if this manifold has
two dimensions, or as an embedded surface if the current working manifold has three dimensions.\,%
\footnote {{} Not to be confused with the geometric dimension. For instance, if we are trying to mesh
a surface in $ \mathbb R^3 $, the current working manifold has (topological) dimension two,
while the geometric dimension (the number of coordinates) is three.}
These normal vectors provide the sense in which we want the mesh to grow (towards one side or the other
of the interface).
They are used for defining the location of each new vertex.

For a two-dimensional mesh in $ \mathbb{R}^2 $ or a three-dimensional mesh in $ \mathbb{R}^3 $,
the normals are built using the intrinsic orientation.
In $ \mathbb{R}^2 $ a mere $ 90^\circ $ rotation of the segment is enough.
In $ \mathbb{R}^3 $ we need to use the exterior product of two vectors.
If the metric is anisotropic, the normal thus obtained must be corrected
(in three dimensions, even if the metric is isotropic, the exterior product must be rescaled).
Classes {\small\tt ExtProd2d} and {\small\tt ExtProd3d} (hidden in anonymous namespace)
deal with this construction through their method {\small\tt get\_\,normal\_\,vector}.

The ``correction'' above referred (when the metric is anisotropic) consists of multiplying
the rotated vector (or the exterior product), to the left, by $ \det A\;A^{-2} $
(that is, by $ \sqrt{\det M}\;M^{-1} $), using the notations in paragraphs
\ref{\numb section 3.\numb parag 27} and \ref{\numb section 3.\numb parag 28}.

Note that the interface is ``looking outwards'', towards the zone where we do not intend
to build triangles/tetrahedra (either because this zone has already been meshed or because
it is not part of the domain to be meshed).
Method {\small\tt get\_\,normal\_\,vector} returns the reversed normal, pointing towards
the zone where we intend to build triangles/tetrahedra.

The process is quite different when building a two-dimensional mesh in $ \mathbb{R}^3 $
(we call this situation ``co-dimension one'').
Often, at the beginning of the process only one segment has an associated normal vector.
{\ManiFEM} then propagates this normal vector to the neighbour segments, walking along
the current connected component of the interface.
This means that, if there are other connected components, they will have no normal vectors.
When the current connected component of the interface touches other connected components
(this event is discussed in paragraph \ref{\numb section 13.\numb parag 11}), {\maniFEM}
% aproveita a oportunidade para ...
propagates the normal vectors to the new connected component.
Each time a new segment is added to the interface, the normal associated to the new segment
must be computed (inferred from information at neighbour segments).
The class {\small\tt NormalContainer} (hidden in anonymous namespace) deals with this process.


          %-----------------%
\section{~~Filling triangles}\label{\numb section 13.\numb parag 10}
          %-----------------%

Perhaps the simplest part of the frontal meshing process with triangles
is just walking along the interface and adding new triangles.

A trivial case is when an angle is encountered which is close to $ 60^\circ $
(see figure \ref{\numb section 13.\numb fig 6} left).
Then we only have to fill the space with a new triangle.
Of course, before creating this new triangle a new segment {\small\tt AC} must be created
(no new vertex is needed).
Segments {\small\tt AB} and {\small\tt BC} are removed from the interface then {\small\tt AC} is added.
Its normal vector must be computed (see paragraph \ref{\numb section 13.\numb parag 9}).

\begin{figure}[ht] \centering
  \psfrag{P}{\small\tt\textcolor{textindraw}{P}}
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
\begin{subfigure}{71mm}\centering
  \includegraphics[width=50mm]{fill-angle-60}
\end{subfigure}  
\begin{subfigure}{71mm}\centering
  \includegraphics[width=50mm]{fill-angle-120}
\end{subfigure}  
  \caption{filling a $ 60^\circ $ angle and a $ 120^\circ $ angle}
  \label{\numb section 13.\numb fig 6}
\end{figure}

Another situation is when an angle is encountered which is close to $ 120^\circ $
(see figure \ref{\numb section 13.\numb fig 6} right).
A new vertex {\small\tt P} is created; its position is defined based on the two normals
of the adjacent segments.
Three new segments {\small\tt AP}, {\small\tt BP} and {\small\tt CP} are created,
then two new triangles are created and added to the mesh under construction.
Segments {\small\tt AB} and {\small\tt BC} are removed from the interface then
{\small\tt AP} and {\small\tt PC} are added to the interface (their normals must be computed).

The algorithm then searches for vertices close to {\small\tt P}, building a list of them with the aid of
the {\small\tt MetricTree} described in paragraph \ref{\numb section 13.\numb parag 14}.
These may include, besides {\small\tt A}, {\small\tt B} and {\small\tt C},
other vertices, marked by blue dots in figure \ref{\numb section 13.\numb fig 7}.
The algorithm improves the location of {\small\tt P} by trying to make all these distances
as close to $1$ as possible (see paragraphs \ref{\numb section 13.\numb parag 7} and
\ref{\numb section 13.\numb parag 12}).

\begin{figure}[ht] \centering
  \psfrag{P}{\small\tt\textcolor{textindraw}{P}}
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
\begin{subfigure}{80mm}\centering
  \includegraphics[width=55mm]{fill-angle-120-a}
\end{subfigure}
% \hskip 5mm
\begin{subfigure}{70mm}\centering
  \includegraphics[width=45mm]{fill-angle-120-b}
\end{subfigure}  
\caption{blue dots show vertices close to {\small\tt P}
  (besides {\small\tt A}, {\small\tt B}, {\small\tt C})}
  \label{\numb section 13.\numb fig 7}
\end{figure}

In certain instances, the algorithm decides to create a ``bridge'' between {\small\tt P} and
one of these blue-dotted vertices.
This process is described in paragraph \ref{\numb section 13.\numb parag 11}.

Finally, if all angles of the current connected component of the interface are wide,
the algorithm creates a triangle ``out of the blue'', like in figure \ref{\numb section 13.\numb fig 8}.
Segment {\small\tt AB} is removed from the interface then {\small\tt AP} and {\small\tt PB}
are added to the interface (their normals must be computed).

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{P}{\small\tt\textcolor{textindraw}{P}}
  \includegraphics[width=45mm]{fill-blue}
  \caption{creating a new triangle}
  \label{\numb section 13.\numb fig 8}
\end{figure}

Again, the position of the newly created angle is iteratively improved such that distances
to nearby vertices are as close to $1$ as possible
(see paragraph \ref{\numb section 13.\numb parag 7});
a bridge may be created (see paragraph \ref{\numb section 13.\numb parag 11}).


          %-----------------%
\section{~~Creating a bridge}\label{\numb section 13.\numb parag 11}
          %-----------------%

After the creation of a new vertex {\small\tt P} during one of the operations described in
paragraph \ref{\numb section 13.\numb parag 10},
the algorithm may detect vertices geometrically close to {\small\tt P} but
far from it from the viewpoint of the connectivity of the interface
(see figure \ref{\numb section 13.\numb fig 9}).
They may even belong to new connected components of the interface, not yet dealt with.
The {\small\tt MetricTree}, described in paragraph \ref{\numb section 13.\numb parag 14},
helps to search for these vertices in an efficient manner.

\begin{figure}[ht] \centering
  \psfrag{P}{\small\tt\textcolor{textindraw}{P}}
  \psfrag{Q}{\small\tt\textcolor{textindraw}{Q}}
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \includegraphics[width=60mm]{bridge}
  \caption{creating a bridge}
  \label{\numb section 13.\numb fig 9}
\end{figure}

Among these vertices, the algorithm chooses the one closest to {\small\tt P}
(call it {\small\tt Q}) and builds a bridge.
By ``bridge'' we mean a pair of segments, one pointing from {\small\tt P} to {\small\tt Q} and
another one pointing from {\small\tt Q} to {\small\tt P}.
They are added to the interface which thus gains a strange configuration.
Vertex {\small\tt P} has four neighbour segments and the same holds for {\small\tt Q}.
These segments are interconnected in a specific order.
Before the creation of the bridge, {\small\tt AP} was followed by {\small\tt PB} while {\small\tt EQ}
was followed {\small\tt QF}.
After the creation of the bridge, {\small\tt AP} is followed by {\small\tt PQ} then by {\small\tt QF}
while {\small\tt EQ} is followed by {\small\tt QP} then by {\small\tt PB}.
The class {\small\tt Mesh::STSI}, described in paragraph \ref{\numb section 13.\numb parag 16},
is able to deal with such a strange configuration.

Ideally, the segment {\small\tt QP} should be the reverse of {\small\tt PQ}.
However, none of the types of meshes implemented in {\maniFEM}, not even {\small\tt Mesh::STSI},
allows this.
This is why {\small\tt QP} is initially created as a separate segment, sharing extremities with
{\small\tt PQ} but otherwise independent.
This pair of segments is kept in the map {\small\tt dummy\_faces}.
Later, when adjacent triangles are created, {\small\tt QP} will be replaced by {\small\tt PQ}
{\small\tt .reverse()}.


          %--------------------%
\section{~~About {\tt relocate}}\label{\numb section 13.\numb parag 12}
          %--------------------%

The coordinates of each newly created vertex {\small\tt P} are initially computed
based on a number of faces in the interface (by ``faces'' we mean segments
if we are building a mesh of triangles, triangles if we are building a mesh of tetrahedra).
After that, a rather complicated algorithm is applied in order to relocate (improve the
position of) the vertex.
When building a mesh of tetrahedra, this process involves creating new tetrahedra around
the vertex, while relocating it at the same time.


          %------------------%
\section{~~Filling tetrahedra}\label{\numb section 13.\numb parag 13}
          %------------------%

When meshing frontally a three-dimensional domain,
the user must provide a two-dimensional mesh with no boundary (a closed surface) made of triangles;
{\maniFEM} will produce a mesh of tetrahedra filling the region of $ \mathbb R^3 $
bounded by that closed surface.

Of course the algorithm for building tetrahedra is more complex than the one for triangles.
It looks for ``cavities'' in the interface and tries to fill them with tetrahedra.
Newly created vertices are relocated in order for distances to other nearby vertices
to be close to $1$, but distances to triangles are also taken into account, as well as certain
angles.

While in two dimensions we build bridges in order to allow for topological changes,
in three dimensions we build filaments and membranes.
A membrane is simply a pair of triangles sharing the same sides, with opposite orientations;
it can be viewed as the 3D equivalent of a bridge.
A filament is a pair of degenerated faces, having two sides.
Just like for membranes, these sides are shared, with opposite orientations.

We do not include drawings about three-dimensional frontal meshing in this manual because such
drawings are difficult to understand in static form.
We prefer to keep files in the {\small\tt msh} format within the repository
{\small\tt https://codeberg.org/cristian.barbarosie/manifem-manual}.
The user can then interact with these files using e.g.\ the {\small\tt gmsh} software.
These files are refered to in the source code (file {\small\tt frontal-3d.cpp}).


          %---------%
\section{~~The {\tt MetricTree}}\label{\numb section 13.\numb parag 14}
          %---------%

During the mesh generation process described in paragraphs \ref{\numb section 13.\numb parag 6}\,--\,%
\ref{\numb section 13.\numb parag 13}, we have to check frequently the distance between
a newly built vertex and all other vertices of the evolving interface
(including other connected components).
A direct comparison with all vertices would be very time consuming, so we rely on a tree-like
structure which we call {\small\tt\verm{MetricTree}} and which eliminates many vertices from the list
of candidates.

The {\small\tt\verm{MetricTree}} is similar to quad- and oct-trees with two differences\,:
there is no assumption on the geometric dimension and the zones overlap.
It is similar to m-trees, just not balanced.

It works for a general metric space.
Triangular inequality is assumed, as well as symmetry.
Because it is not balanced, it deals well with non uniform clouds of points, that is,
with clouds having zones with high density of points along with
zones where the points are spread at large distances.

There is no upper limit on the number of children.
Actually, the average number of children can be interpreted as a hint about the dimension of the
metric space (in the spirit of Hausdorff dimension).
\vfil\eject

{\small\tt\verm{MetricTree}} has been implemented with the intent of having wide usability,
independently\,%
\footnote {{} {\footnotesize\tt\verm{MetricTree}} is available separately at
{\footnotesize\tt https://codeberg.org/cristian.barbarosie/MetricTree}}
of \maniFEM.
It is templated over the type of {\small\tt Point}\hglue0.5pt s (the metric space) and over a callable
object returning the square of the distance between any two {\small\tt Point}\hglue0.5pt s.
% However, it still needs the touch of someone experienced in the subtleties of {\tt C++}.
% Help is welcome.

We focus on the square of the distance rather than on the distance itself because it
is numerically cheaper (we prefer not to compute square roots).
Of course there are parts of the code where the true distance must be used
(e.g.\ when it comes to the triangular inequality).
Even there, simple algebraic manipulations allow us to avoid computing any square root.

The user interacts with the {\small\tt\verm{MetricTree}} through four methods.
The constructor sets the rank-zero distance and the ratio between successive
distances (see below).
Method {\small\tt add} adds a {\small\tt Point} to the cloud and returns a pointer to a
{\small\tt Node} which the user must keep and later provide to the {\small\tt remove} method.
The {\small\tt remove} method removes a {\small\tt Node} from the {\small\tt\verm{MetricTree}}.
Finally, and most importantly, method {\small\tt find\_\,close\_\,neighbours\_\,of} receives a
{\small\tt Point P} and a distance threshold and returns a list of {\small\tt Node}\hglue0.5pt s near
{\small\tt P}.
It is irrelevant whether {\small\tt P} belongs or not to the cloud (if it belongs, it will
show up in the returned list, disguised as a {\small\tt Node}).
The user can recover (a copy of) the {\small\tt Point} from a {\small\tt Node} using the attribute
{\small\tt point}.
We have not implemented a method for finding the $n$ nodes closest to a given point
(we do not need such an operation for frontal mesh generation).

It is assumed that {\small\tt Point}\hglue0.5pt s are cheap to copy.
If this is not the case for your {\small\tt Point}\hglue0.5pt s, use pointers.
{\ManiFEM} uses wrappers, which are a sort of pointers (see paragraph
\ref{\numb section 12.\numb parag 4}).

Each node represents a point.
Leaves have no special status.
Each node has a rank which is an integer, possibly zero, possibly negative.
Children of a node {\small\tt N} have rank equal to {\small\tt rank[N]-\laranja{1}}.
Nodes with rank zero have no special status.
Leaves may have any rank, positive, zero or negative.
There is a {\small\tt root} of course (a node with no parent).
The root has the highest rank.
Even the rank of the root may be negative (which means all nodes have negative ranks).

To each rank there is a distance {\small\tt dist} associated.
Children of a node {\small\tt N} are no farther than {\small\tt dist[rank[N]]} from {\small\tt N}.
Note that a point {\small\tt P} being at distance less than {\small\tt dist[rank[N]]} from
{\small\tt N} does not imply that {\small\tt P} must be a child (not even an indirect descendant)
of {\small\tt N}.
In other words\,: zones overlap.

{\small\tt dist[k]} is a geometric sequence with ratio {\small\tt ratio}.
{\small\tt ratio} must be greater than two; we recommend some value between five and ten.
So, {\small\tt dist[k] == ratio}$^{\hbox{\footnotesize\tt k }}${\small\tt dist[\laranja{0}]}.
Recall that {\small\tt k} may be negative.

Besides the {\small\tt dist}ance, to each rank {\small\tt k} we associate a {\small\tt range}
which represents the sum of distances of that rank and of all lower ranks.
That is,
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   range[k] == dist[k] / ( \laranja{1} - \laranja{1} / ratio )\,; \ range[k] > dist[k].
\end{Verbatim}
\noindent This means that an indirect descendant of a node {\small\tt N} cannot be farther than
{\small\tt range[rank[N]]} from {\small\tt N}.
Again, the reverse may be false.

\begin{figure}[ht] \centering
  \includegraphics[width=165mm]{metric-tree}
  \caption{metric tree}
  \label{\numb section 13.\numb fig 10}
\end{figure}

Figure \ref{\numb section 13.\numb fig 10} shows a cloud of (randomly generated) points in
$ \mathbb{R}^2 $ organized in a {\small\tt\verm{MetricTree}}.
It also illustrates the process of {\small\tt find\_\,close\_\,neighbours\_\,of} a given point.
This method takes two arguments\,: a {\small\tt Point} (drawn in red) and a distance.
It returns a list (drawn in blue) of all {\small\tt Node}\hglue0.5pt s in the cloud which are close enough
to the red point (closer than the given distance).
It is irrelevant whether the red point belongs to the cloud or not;
in figure \ref{\numb section 13.\numb fig 10} it does not.

Figure \ref{\numb section 13.\numb fig 10} shows grey dots at nodes which have been analysed
during the process of {\small\tt find\_\,close\_\,neighbours}
(their distance to the red dot has been computed).
Lines without a dot represent nodes in the {\small\tt\verm{MetricTree}} which have not even been
looked at because their parent has decided (based on the triangular inequality)
that they cannot be close enough to the red dot.
Their distance to the red point has not been computed, thus alleviating the computational
burden.

If you want to run this example on your computer, it suffices to download three files
({\small\tt Makefile}, {\small\tt metric-tree-verbose.h} and
{\small\tt parag-\ref{\numb section 13.\numb parag 14}.cpp}) from\hfil\break
{\small\tt https://codeberg.org/cristian.barbarosie/maniFEM}\hfil\break
then {\small\tt make} {\small\tt run-parag-\ref{\numb section 13.\numb parag 14}}


          %---------------------%
\section{~~Triangular inequality}\label{\numb section 13.\numb parag 15}
          %---------------------%

The implementation of the {\small\tt\verm{MetricTree}}, described in paragraph
\ref{\numb section 13.\numb parag 14}, assumes the triangular inequality holds.
Without this assumption, there is no guarantee that a call to
{\small\tt find\_\,close\_\,neighbours\_\,of} will find all requested {\small\tt Node}\hglue0.5pt s.

This rises a problem when non-uniform meshes are built,
either by providing a {\small\tt\verm{Function}} as desired length, as illustrated in
paragraphs \ref{\numb section 3.\numb parag 23} and \ref{\numb section 3.\numb parag 24},
or by manipulating the Riemann metric of the manifold, as in paragraphs
\ref{\numb section 3.\numb parag 26}\,--\,\ref{\numb section 3.\numb parag 30}.
The problem shows up when the metric depends on the point (is non-uniform);
it is not due to the anisotropy of the metric.
First, we shall explain the problem, then we shall explain how we circumvented it.

Specifying a ``Riemann metric'' on a differentiable manifold $X$ means specifying an inner product
on the tangent space of $X$, at every point $ P\in X $.
Such an inner product allows one to define the length of a curve $ \Gamma $ embeded in $X$\,:
if $ r : [a,b] \to X $ is a parametrization of $ \Gamma $, the length of $ \Gamma $ is given by
$ \displaystyle \int_a^b \sqrt {\Bigl\langle r'(t),r'(t)\Bigr\rangle_{r(t)}}\; dt $, where
$ \bigl\langle u,v \bigr\rangle_P $ denotes the inner product between two vectors $u$ and $v$
in the tangent space of $X$ at point $P$.
Subsequently, one may regard $X$ as a metric space by defining the distance between
any two points as the infimum of the lengths of all curves joining the two points;
this is called ``geodesic distance''.

The geodesic distance is a very elegant and convenient mathematical construction,
but from the computational point of view it is useless.
It is prohibitive to compute the distance between two points by measuring the length
of all paths between those two points and then choosing the shortest one.
This is why {\maniFEM} uses a different ``distance''.
Assuming $X$ is a submanifold of $ {\mathbb R}^n $, we define the ``distance'' between two points
$A$ and $B$ as $ \displaystyle \sqrt { {1\over 2} \left\langle \vv{AB}, \vv{AB} \right\rangle_A +
{1\over 2} \left\langle \vv{AB}, \vv{AB} \right\rangle_B } $.
This quantity is a reasonable approximation of the geodesic distance if the two
points $A$ and $B$ are close enough to each other.
However, there is no reason for it to satisfy the triangular inequality for points far from each other.
% (it is easy to prove numerically that it does not).
Actually, it is easy to prove numerically that, if the metric $ \langle\cdot,\cdot\rangle_P $
depends on the point $ P\in X $, the above defined quantity infringes the triangular inequality
(even if the metric is isotropic).

This means that, although it is OK to use the above defined ``distance'' in order to measure
short segments, we cannot use it in the {\small\tt\verm{MetricTree}}
(because the algorithm behind {\small\tt\verm{MetricTree}} is not local, it deals with points
which are far away from each other, and it relies on the triangular inequality).
This is why we provide the usual Euclidian distance (squared) when declaring the
{\small\tt\verm{MetricTree}}.\,%
\footnote {{} Ironically, {\footnotesize\tt\verm{MetricTree}} was designed with the goal of dealing
with arbitrary metric spaces (and it does deal).
The initial intention was to feed it directly the anisotropic Riemann metric.
We later realized that this was not feasible for a non-uniform metric, as explained above,
so we ended up using the {\footnotesize\tt\verm{MetricTree}} with the trivial Euclidian metric.}
And we must ensure the compatibility between this choice and the fact that the rest of the
frontal mesh generation algorithm uses a modified Riemann metric.

It is easy to ensure this compatibility if the metric is isotropic.
We simply provide a rescaled length when we invoke {\small\tt find\_\,close\_\,neighbours\_\,of}.
To prevent any error, we check each point in the returned list with the Riemann metric.

But for an anisotropic mesh things are more complicated.
We have chosen the following work-around.
We use as scaling factor the inner spectral radius of the matrix $M$ defining the Riemann metric
(i.e.\ a lower bound on its eigenvalues, or, equivalently, an upper bound
on the spectral radius of the inverse matrix).
Providing separately the ``principal part'' and the ``deviatoric part'', as shown in
paragraphs \ref{\numb section 3.\numb parag 29} and \ref{\numb section 3.\numb parag 30}, helps.
The principal part is a positive scalar $ \sigma $ times the identity matrix,
while the deviatoric part is a matrix $D$ responsible for the anisotropy;
$D$ should be semi-definite positive.
Desirably, $D$ should be a singular matrix (having a null eigenvalue);
this way, the inner spectral radius is equal to $ \sigma $.

If we provide only the sum $M$ as in paragraph \ref{\numb section 3.\numb parag 27}
(or only $ \sqrt M $ as in paragraph \ref{\numb section 3.\numb parag 28}),
{\maniFEM} will compute, at each step,  the inner spectral radius, which may be
a heavy computational burden.

Again, we filter the list of points returned by {\small\tt find\_\,close\_\,neighbours\_\,of}
by checking them against the Riemann metric.
When the metric is highly anisotropic, the list returned by method
{\small\tt find\_\,close\_\,neighbours\_\,of} will be singnificantly larger than the correct,
filtered, list.

See also the limitations of the frontal mesh generation algorithm described in paragraph
\ref{\numb section 3.\numb parag 15}.


          %-----------%
\section{~~STSI meshes}\label{\numb section 13.\numb parag 16}
          %-----------%

Usually, meshes in {\maniFEM} belong to one of the classes {\small\tt\verm{Mesh}::Connected::OneDim} or
{\small\tt\verm{Mesh}::Fuzzy}.
Neither of these classes is able to reach a configuration like {\small\tt AFBCDEFG} in
figure \ref{\numb section 13.\numb fig 11} (a) or like {\small\tt AFEDCBFG} in figure
\ref{\numb section 13.\numb fig 11} (b) or like the double coffee filter in figure
\ref{\numb section 13.\numb fig 11} (c).
The internal implementation of neighbourhood relations requires that each {\small\tt face} in a mesh
have exactly two neighbours, one behind {\small\tt face} and another one in front of {\small\tt face}.
This does not happen for vertex {\small\tt F} in figure \ref{\numb section 13.\numb fig 11} (a) (b),
nor for segments along {\small\tt AB} in figure \ref{\numb section 13.\numb fig 11} (c).

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \psfrag{G}{\small\tt\textcolor{textindraw}{G}}
  \includegraphics[width=40mm]{stsi-1}\hskip3mm
  \includegraphics[width=40mm]{stsi-2}
  \includegraphics[width=60mm]{filter}
  \centerline{(a)\hskip40mm (b)\hskip45mm (c)\hglue 15mm}
  \caption{self-crossing, self-touching meshes}
  \label{\numb section 13.\numb fig 11}
\end{figure}

We have implemented a different class called {\small\tt\verm{Mesh}::STSI} which is more
flexible with respect to neighbourhood relations.
The name comes from ``self-touching, self-intersecting meshes''.
It can reach the shape of any of the meshes shown in figure \ref{\numb section 13.\numb fig 11}.

This class is not intended for the final user of \maniFEM.
It is used internally in frontal mesh generation, see paragraph \ref{\numb section 13.\numb parag 11}.
It will also be used in the implementation of iterators over high-dimensional connected meshes.

If {\small\tt msh} is a {\small\tt\verm{Mesh}} having a {\small\tt\verm{Mesh}::STSI} core,
a statement like
{\small\tt cll} {\small\tt .add\_\,to} {\small\tt (} {\small\tt msh} {\small\tt )}
will do things that depend on the configuration of faces of {\small\tt cll}.
If these faces do not belong already to {\small\tt msh}, or if they do belong but have only one
neighbour, the same steps as for a {\small\tt\verm{Mesh}::Fuzzy} will be taken.
If a {\small\tt face} has already two neighbour cells within {\small\tt msh}, that face will receive
a special treatment.
{\small\tt msh} will be erased from {\small\tt face} {\small\tt .core->cell\_\,behind\_\,within}
and an entry will be created for {\small\tt face} in {\small\tt msh} {\small\tt .core->singular}.
A statement like {\small\tt cll} {\small\tt .remove\_\,from} {\small\tt (} {\small\tt msh}
{\small\tt )} will do the reverse.
In ``normal'' situations (i.e.\ for faces having one or two neighbour cells within {\small\tt msh})
it will behave just like for a {\small\tt\verm{Mesh}::Fuzzy}.
If the {\small\tt face} is already singular, the statement may revert it to the ``normal'' configuration.
The above description is imprecise because it does not take orientations into account.

For instance, the configuration in figure \ref{\numb section 13.\numb fig 11} (a) can be obtained by
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Mesh} \azul{msh} ( \taag::STSI, \taag::of_dimension, \laranja{1} );
   AF .add_to ( msh );
   FB .add_to ( msh );
   BC .add_to ( msh );
   CD .add_to ( msh );
   DE .add_to ( msh );
   EF .add_to ( msh );
   FG .add_to ( msh );
\end{Verbatim}
After the first five insertions, {\small\tt msh} has a structure identical to a
{\small\tt\verm{Mesh}::Fuzzy} (in spite of having a {\small\tt\verm{Mesh}::STSI} core).
That is, {\small\tt msh} {\small\tt .core->singular} is an empty map.
After inserting {\small\tt EF}, vertex {\small\tt F} becomes singular;
however, {\small\tt AF} is still follwed by {\small\tt FB} while {\small\tt EF} stays ``alone''.
The last statement links {\small\tt FG} to {\small\tt EF} (rather than to {\small\tt AF})
simply because {\small\tt EF} has no successor and is eager to gain one.

Suppose we add the two statements below\,:
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   AF .remove_from ( msh );
   FG .remove_from ( msh );
\end{Verbatim}
After removing {\small\tt AF}, {\small\tt FB} remains ``alone''.
After removing {\small\tt FG} in the last statement, {\maniFEM} links the two ``orphans''
{\small\tt EF} and {\small\tt FB} and the mesh becomes a closed path (a pentagon) and
returns to a state similar to a {\small\tt Fuzzy} mesh.

In other words, the connections between cells in a {\small\tt STSI} mesh depend on the order
of insertions and removals.

If we add {\small\tt\taag::force} as argument to the method {\small\tt add\_\,to},
{\maniFEM} will break previously existing neighbourhood relations and will
give priority to the newly inserted cell with respect to ``glueing'' to neighbour cells.
For instance, the configuration in figure \ref{\numb section 13.\numb fig 11} (b)
can be obtained by
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Mesh} \azul{msh} ( \taag::STSI, \taag::of_dimension, \laranja{1} );
   FB .add_to ( msh );
   BC .add_to ( msh );
   CD .add_to ( msh );
   DE .add_to ( msh );
   EF .add_to ( msh );
   \cinza{// at this point, 'msh' is a closed path, a pentagon}
   FG .add_to ( msh, \taag::force );
   AF .add_to ( msh );
\end{Verbatim}
When inserting {\small\tt FG}, the existing neighbourhood relation between
{\small\tt EF} and {\small\tt FB} will be broken and {\small\tt EF} will be glued to {\small\tt FG};
{\small\tt FB} becomes orphan.
In the last statement, {\small\tt AF} will be linked to {\small\tt FB}
simply because {\small\tt FB} has no predecessor and is eager to gain one.

\begin{figure}[ht] \centering
  \includegraphics[width=70mm]{yo-yo}
  \caption{double cone}
  \label{\numb section 13.\numb fig 12}
\end{figure}

Incidentally, note that {\small\tt Fuzzy} meshes can take the shape shown in figure
\ref{\numb section 13.\numb fig 12}.


          %------------------------%
\section{~~Variational formulations}\label{\numb section 13.\numb parag 17}
          %------------------------%

Each integral (in the linear and bilinear forms) has its own domain of integration.
The {\small\tt domain} attribute of class {\small\tt\verm{VariationalFormulation}}
in only useful as a collection of vertices, which in turn is useful for vertex numbering.
This attribute is built as the union of all domains (of all integrals) of maximum dimension.
A temporary attribute {\small\tt set\_\,of\_\,domains} is used for keeping these domains.
